<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { privacyDataHelper } from '../../services/privacy/privacy.service';
import { Disclaimer } from '@/components/gartner/index.vue';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  components: {
    Disclaimer,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData({ i18n }) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '3adcg8MHMPWpnK4Wt3yWbZ',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });
      const spaceId = response.items[0].sys.space.sys.id;
      const entryId = response.items[0].sys.id;
      const { pageContent } = response.items[0].fields;

      const doc = privacyDataHelper(pageContent);
      const metadata = response.items[0].fields.seoMetadata[0].fields;
      return { doc, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    if (this.metadata) {
      return getPageMetadata(
        (this as any).metadata,
        this.$route.path,
        this.$nuxtI18nHead({ addSeoAttributes: true }),
      );
    }
  },
  mounted() {
    // **PATCH**: This broken link has been shared with customers
    // This mitigates lost traffic and a broken UX
    if (
      window.location.hash ===
      '#Information%20Processed%20by%20AI-Powered%20Features'
    ) {
      window.location.hash = '#information-processed-by-ai-powered-features';
      const element = document.getElementById(
        'information-processed-by-ai-powered-features',
      );
      if (element) {
        element.scrollIntoView();
      }
    }
    // End PATCH
  },
});
</script>

<template>
  <div class="privacy">
    <SlpContainer class="slp-mb-96">
      <section>
        <SlpTypography
          variant="heading1-bold"
          tag="h1"
          class="slp-mt-64 slp-mb-24"
        >
          {{ doc.hero_title }}
        </SlpTypography>
        <SlpHorizontalRule />
        <SlpTypography class="last-updated slp-mt-16" tag="p" variant="body2">
          {{ doc.last_updated }}
        </SlpTypography>
        <SlpTypography tag="div" variant="body1" class="slp-mt-32">
          <span class="hero-copy" v-html="$md.render(doc.copy)"> </span>
        </SlpTypography>
      </section>
      <div class="hero-gradient slp-mt-64 slp-mb-24"></div>

      <SlpSideNavigation :data="doc.side_menu">
        <section
          v-for="section in doc.sections"
          :id="section.id"
          :key="section.header"
          class="body-copy"
        >
          <SlpTypography tag="h2" variant="heading4-bold" class="slp-my-32">
            {{ section.header }}
          </SlpTypography>
          <SlpTypography tag="div" variant="body2">
            <span v-html="$md.render(section.text)"> </span>
          </SlpTypography>
        </section>
      </SlpSideNavigation>
    </SlpContainer>
    <Disclaimer v-if="doc.disclaimer" v-bind="doc.disclaimer" />
  </div>
</template>

<style lang="scss" scoped>
.privacy > * {
  word-wrap: break-word;
}
.last-updated {
  font-style: italic;
}

.hero-gradient {
  background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
  height: 4px;
  width: 95px;
  border-radius: 10px;
}

.body-copy:deep(table) {
  border-collapse: collapse;
  margin-top: $spacing-16;
  border: 1px solid #eee7fd;
  td,
  th {
    border: 1px solid #eee7fd;
    padding: $spacing-16;
  }
}

.hero-copy:deep,
.body-copy:deep {
  ul {
    list-style-type: disc;
    list-style-position: inside;
    padding-left: 2.3em;
  }

  li {
    margin-bottom: $spacing-8;
  }

  p,
  ul,
  h2,
  h3 {
    margin-bottom: $spacing-16;
  }

  li > p {
    display: inline;
  }

  h3 {
    font-size: $text-heading-5;
    line-height: $line-height-heading-5;
    font-weight: $font-weight-bold;
    margin: $spacing-32 0 $spacing-24 0;
  }
}
</style>
